// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef GAMEOGRE_H
#define GAMEOGRE_H

class State;

class GameOGRE : public Singleton<GameOGRE>
{
public:
	GameOGRE(Camera* camera, Camera* reflectcamera, 
           Camera* reflectcamera2, SceneManager* scenemanager, 
           RenderWindow* window);
	~GameOGRE();	
  
	// Update functions
	void invalidate(int updateFlags);
	void Update(Real dt);    
  void Pause(bool toggle) {mPaused = toggle;}  
  Ray CreateRay(void);

	Ogre::Vector3 mCameraTarget;
	Real mCameraWantedYaw;
	Real mCameraWantedPitch;
	Real mCameraWantedDistance;
	Real mCameraCorrection;	          

protected:
  std::vector<State*> mStates;	  
	Camera *mCamera, *mReflectCamera, *mReflectCameraGround;  
  SceneManager *mSceneManager;	       
  RenderWindow* mWindow;
  bool mPaused;
};

#endif
