// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#ifndef GAMESTATE_H
#define GAMESTATE_H

#include "ChessState.h"

class Piece;
class ChessInputManager;

class GameState : public ChessState
{
public:
  GameState();
  virtual ~GameState();
  // State overrides
	virtual void pause();
	virtual void resume();
	virtual void keyPressed(const KeyEvent & e);    
	virtual void mouseMoved(const MouseEvent & e);
	virtual void mousePressed(const MouseEvent & e);
	virtual void mouseReleased(const MouseEvent & e);
  virtual void frameStarted(Real dt);

protected: 
	Real mSavedCameraYaw;
	Real mSavedCameraPitch;
  bool mLMouseDown;
  bool mRMouseDown;  

  RaySceneQuery *mRaySceneQuery;  
  Ogre::Plane *mPlane;
  Piece *mSelectedPiece;
  SceneManager *mSceneManager;
  ChessInputManager *mInputManager;
  bool mPieceSelected;
  int mCurrentPosition;

};

#endif
