// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "CPUvCPUState.h"
#include "GameAI.h"
#include "Player.h"

// Singleton instance
template<> CPUvCPUState* Singleton<CPUvCPUState>::ms_Singleton = 0;

// State overrides
void CPUvCPUState::initialize()
{    
	// Initialize game state
	GameState::initialize();	
  // finish any running games
  if (mGameAI!=0) mGameAI->EndGame();
  mGameAI->InitializeGame();  
  // set up the players
  mGameAI->SetPlayer(Player::SIDE_WHITE, Player::TYPE_AI);
  mGameAI->SetPlayer(Player::SIDE_BLACK, Player::TYPE_AI);      
}
