// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "CollisionManager.h"
#include "CollisionEntity.h"
#include "Collider.h"

template<> CollisionManager* Singleton<CollisionManager>::ms_Singleton = 0;

CollisionManager& CollisionManager::getSingleton(void)
{
   return Singleton<CollisionManager>::getSingleton();
}

CollisionManager::CollisionManager() : mCollider(0) 
{ 	  
	createCollider();
}

CollisionManager::~CollisionManager() { 	
  delete mCollider;
}
  
bool CollisionManager::createCollider(void)
{
	mCollider = new Collider();
	if(!mCollider) return false;
	return true;
}

CollisionEntity* CollisionManager::createEntity(Entity* const ent) 
{ 
  CollisionEntity* ce = new CollisionEntity(ent);
  ce->Initialise();
	return ce;
}

bool CollisionManager::collide(Ogre::Ray* ray, CollisionEntity* entity) 
{
  return mCollider->collide(ray, entity);
}  