// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "ColourState.h"
#include "GameAI.h"
#include "Player.h"
#include "StateManager.h"

// Singleton instance
template<> ColourState* Singleton<ColourState>::ms_Singleton = 0;

ColourState::GameType ColourState::Players = ColourState::PvCPU;

ColourState::ColourState()
{
	OverlayManager* overlayManager = OverlayManager::getSingletonPtr();

	// Set this menu's overlay
	mMenuOverlay = static_cast<Overlay*>(OverlayManager::getSingleton().getByName("Menu/ColourMenu"));

  // Add menu items  
	mMenuItems.push_back(overlayManager->getOverlayElement("ColourMenu/1P"));
  mMenuItems.push_back(overlayManager->getOverlayElement("ColourMenu/2P"));  

}

void ColourState::onSelected(MenuItemList::iterator item)
{  
	if ((*item)->getCaption() == "1P")
	{	
    // Pop the main menu state
		StateManager::getSingleton().popState();    
    // set up the players
    if (ColourState::Players == ColourState::PvP)     {		  
      mGameAI->SetPlayer(Player::SIDE_WHITE, Player::TYPE_HUMAN);
      mGameAI->SetPlayer(Player::SIDE_BLACK, Player::TYPE_HUMAN);  
    } else {		  
      mGameAI->SetPlayer(Player::SIDE_WHITE, Player::TYPE_HUMAN);
      mGameAI->SetPlayer(Player::SIDE_BLACK, Player::TYPE_AI);
    }		
	}
  else if ((*item)->getCaption() == "2P")
	{		
    // Pop the main menu state
		StateManager::getSingleton().popState();    
    // set up the players    		  
    mGameAI->SetPlayer(Player::SIDE_WHITE, Player::TYPE_HUMAN);
    mGameAI->SetPlayer(Player::SIDE_BLACK, Player::TYPE_HUMAN);      
	}
  else if ((*item)->getCaption() == "CPU")
	{		
    // Pop the main menu state
		StateManager::getSingleton().popState();    
    // set up the players    		  
    mGameAI->SetPlayer(Player::SIDE_WHITE, Player::TYPE_AI);
    mGameAI->SetPlayer(Player::SIDE_BLACK, Player::TYPE_HUMAN);      
	}
  // start the game AI
  mGameAI->Start();  
}
