// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "GameOverState.h"
#include "MainMenuState.h"

// Singleton instance
template<> GameOverState* Singleton<GameOverState>::ms_Singleton = 0;

GameOverState::GameOverState()
{
	OverlayManager* overlayManager = OverlayManager::getSingletonPtr();	
	mMenuOverlay = static_cast<Overlay*>(OverlayManager::getSingleton().getByName("Menu/GameOverMenu"));  	
}

void GameOverState::DisplayResult(const String outcome, const String winner)
{  
  OverlayManager* overlayManager = OverlayManager::getSingletonPtr();	
  overlayManager->getOverlayElement("GameOverMenu/Outcome")->setCaption(outcome);
  overlayManager->getOverlayElement("GameOverMenu/Winner")->setCaption(winner);
}

void GameOverState::keyPressed(const KeyEvent & e)
{
	ChessState::keyPressed(e);
	// Return to main menu
	changeState(MainMenuState::getSingletonPtr());
}
