// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "PromotionMenuState.h"
#include "GameAI.h"
#include "StateManager.h"

// Singleton instance
template<> PromotionMenuState* Singleton<PromotionMenuState>::ms_Singleton = 0;

PromotionMenuState::PromotionMenuState()
{
	OverlayManager* overlayManager = OverlayManager::getSingletonPtr();

	// Set this menu's overlay
	mMenuOverlay = static_cast<Overlay*>(OverlayManager::getSingleton().getByName("Menu/PromotionMenu"));

  // Add menu items  
	mMenuItems.push_back(overlayManager->getOverlayElement("PromotionMenu/Queen"));
  mMenuItems.push_back(overlayManager->getOverlayElement("PromotionMenu/Rook"));
  mMenuItems.push_back(overlayManager->getOverlayElement("PromotionMenu/Bishop"));
  mMenuItems.push_back(overlayManager->getOverlayElement("PromotionMenu/Knight"));

}

void PromotionMenuState::onSelected(MenuItemList::iterator item)
{
  // set which piece is to be promoted
	GameAI::getSingletonPtr()->SetPromotion((*item)->getCaption());
  // leave this state
  StateManager::getSingleton().popState();
}
