// Chess 
// Copyright (C) 2005  Steve Driscoll (steviedisco@gmail.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

#include "stdafx.h"
#include "PvCPUState.h"
#include "GameAI.h"
#include "ColourState.h"

// Singleton instance
template<> PvCPUState* Singleton<PvCPUState>::ms_Singleton = 0;

// State overrides
void PvCPUState::initialize()
{  
	// Initialize game state
	GameState::initialize();	
  // finish any running games
  if (mGameAI!=0) mGameAI->EndGame();
  mGameAI->InitializeGame(); 
  // set the game type
  ColourState::Players = ColourState::PvCPU;
  // change the colour menu options
  OverlayManager* overlayManager = OverlayManager::getSingletonPtr();
	overlayManager->getOverlayElement("ColourMenu/1P")->setCaption("1P");
  overlayManager->getOverlayElement("ColourMenu/2P")->setCaption("CPU");
}
